#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.3'
__CHEETAH_versionTuple__ = (2, 4, 3, 'development', 0)
__CHEETAH_genTime__ = 1292027730.757496
__CHEETAH_genTimestamp__ = 'Sat Dec 11 00:35:30 2010'
__CHEETAH_src__ = 'spec.tmpl'
__CHEETAH_srcLastModified__ = 'Wed Nov 24 04:42:21 2010'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class spec(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(spec, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''# 
# Do NOT Edit the Auto-generated Part!
# Generated by: spectacle version ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.MyVersion",True) # u'${metadata.MyVersion}' on line 3, col 35
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.MyVersion}')) # from line 3, col 35.
        write(u'''
# 
''')
        str_newline = '\n'
        write(u'''# >> macros
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("macros") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.macros",True),"has_key",False)("main"): # generated from line 7, col 1
            _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.macros.main",True)) # u'$str_newline.join($extra.content.macros.main)' on line 8, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.macros.main)')) # from line 8, col 1.
            write(u'''
''')
        write(u'''# << macros
''')
        if VFSL([locals()]+SL+[globals(), builtin],"extra.HasStatic",True): # generated from line 11, col 1
            write(u'''%define keepstatic 1
''')
            cfgstatic = ""
        else: # generated from line 14, col 1
            cfgstatic = "--disable-static"
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)('Builder'): # generated from line 17, col 1
            Builder = VFSL([locals()]+SL+[globals(), builtin],"metadata.Builder",True)
        else: # generated from line 19, col 1
            #  default
            Builder = 'make'
        write(u'''
''')
        if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'python': # generated from line 24, col 1
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("BuildArch") and VFSL([locals()]+SL+[globals(), builtin],"metadata.BuildArch",True) == 'noarch': # generated from line 25, col 1
                write(u'''%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
''')
            else: # generated from line 27, col 1
                write(u'''%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
''')
        write(u'''Name:       ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Name",True) # u'${metadata.Name}' on line 31, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Name}')) # from line 31, col 13.
        write(u'''
Summary:    ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Summary",True) # u'${metadata.Summary}' on line 32, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Summary}')) # from line 32, col 13.
        write(u'''
Version:    ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Version",True) # u'${metadata.Version}' on line 33, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Version}')) # from line 33, col 13.
        write(u'''
Release:    ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Release",True) # u'${metadata.Release}' on line 34, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Release}')) # from line 34, col 13.
        write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Epoch"): # generated from line 35, col 1
            write(u'''Epoch:      ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Epoch",True) # u'${metadata.Epoch}' on line 36, col 13
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Epoch}')) # from line 36, col 13.
            write(u'''
''')
            auto_depend = "%{epoch}:%{version}-%{release}"
        else: # generated from line 38, col 1
            auto_depend = "%{version}-%{release}"
        write(u'''Group:      ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Group",True) # u'${metadata.Group}' on line 41, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Group}')) # from line 41, col 13.
        write(u'''
License:    ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.License",True) # u'${metadata.License}' on line 42, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.License}')) # from line 42, col 13.
        write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("ExclusiveArch"): # generated from line 43, col 1
            write(u'''ExclusiveArch:  ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.ExclusiveArch",True) # u'${metadata.ExclusiveArch}' on line 44, col 17
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.ExclusiveArch}')) # from line 44, col 17.
            write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("BuildArch"): # generated from line 46, col 1
            write(u'''BuildArch:  ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.BuildArch",True) # u'${metadata.BuildArch}' on line 47, col 13
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.BuildArch}')) # from line 47, col 13.
            write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Prefix"): # generated from line 49, col 1
            write(u'''Prefix:  ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Prefix",True) # u'${metadata.Prefix}' on line 50, col 10
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Prefix}')) # from line 50, col 10.
            write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("URL"): # generated from line 52, col 1
            write(u'''URL:        ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.URL",True) # u'${metadata.URL}' on line 53, col 13
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.URL}')) # from line 53, col 13.
            write(u'''
''')
        #  Sources
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Sources"): # generated from line 56, col 1
            idx = 0
            for source in VFSL([locals()]+SL+[globals(), builtin],"metadata.Sources",True): # generated from line 58, col 1
                write(u'''Source''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"idx",True) # u'${idx}' on line 59, col 7
                if _v is not None: write(_filter(_v, rawExpr=u'${idx}')) # from line 59, col 7.
                write(u''':    ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"source",True) # u'$source' on line 59, col 18
                if _v is not None: write(_filter(_v, rawExpr=u'$source')) # from line 59, col 18.
                write(u'''
''')
                idx = VFSL([locals()]+SL+[globals(), builtin],"idx",True) + 1
        write(u'''Source100:  ''')
        _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Name",True) # u'${metadata.Name}' on line 63, col 13
        if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Name}')) # from line 63, col 13.
        write(u'''.yaml
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RpmLintIgnore"): # generated from line 64, col 1
            write(u'''Source101:  ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Name",True) # u'${metadata.Name}' on line 65, col 13
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Name}')) # from line 65, col 13.
            write(u'''-rpmlintrc
''')
        #  Patches
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Patches"): # generated from line 68, col 1
            idx = 0
            for patch in VFSL([locals()]+SL+[globals(), builtin],"metadata.Patches",True): # generated from line 70, col 1
                #  checking arch namespace prefix
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"patch",True),"startswith",False)('arm:'): # generated from line 72, col 1
                    arch = '%{arm}'
                    patch = VFSL([locals()]+SL+[globals(), builtin],"patch",True)[4:]
                elif VFN(VFSL([locals()]+SL+[globals(), builtin],"patch",True),"startswith",False)('ix86:'): # generated from line 75, col 1
                    arch = '%{ix86}'
                    patch = VFSL([locals()]+SL+[globals(), builtin],"patch",True)[5:]
                else: # generated from line 78, col 1
                    arch = ""
                #  end of checking
                if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 82, col 1
                    write(u'''%ifarch ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"arch",True) # u'$arch' on line 83, col 9
                    if _v is not None: write(_filter(_v, rawExpr=u'$arch')) # from line 83, col 9.
                    write(u'''
Patch''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"idx",True) # u'${idx}' on line 84, col 6
                    if _v is not None: write(_filter(_v, rawExpr=u'${idx}')) # from line 84, col 6.
                    write(u''':     ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"patch",True) # u'$patch' on line 84, col 18
                    if _v is not None: write(_filter(_v, rawExpr=u'$patch')) # from line 84, col 18.
                    write(u'''
%endif
''')
                else: # generated from line 86, col 1
                    write(u'''Patch''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"idx",True) # u'${idx}' on line 87, col 6
                    if _v is not None: write(_filter(_v, rawExpr=u'${idx}')) # from line 87, col 6.
                    write(u''':     ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"patch",True) # u'$patch' on line 87, col 18
                    if _v is not None: write(_filter(_v, rawExpr=u'$patch')) # from line 87, col 18.
                    write(u'''
''')
                idx = VFSL([locals()]+SL+[globals(), builtin],"idx",True) + 1
                #  each patch
        if 'NoAutoReq' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 92, col 1
            write(u'''AutoReq: 0
''')
        if 'NoAutoReqProv' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 95, col 1
            write(u'''AutoReqProv:    0
''')
        #  Requires
        if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'perl': # generated from line 99, col 1
            write(u'''Requires:   perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Requires"): # generated from line 102, col 1
            for req in VFSL([locals()]+SL+[globals(), builtin],"metadata.Requires",True): # generated from line 103, col 1
                #  checking arch namespace prefix
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"req",True),"startswith",False)('arm:'): # generated from line 105, col 1
                    arch = '%{arm}'
                    req = VFSL([locals()]+SL+[globals(), builtin],"req",True)[4:]
                elif VFN(VFSL([locals()]+SL+[globals(), builtin],"req",True),"startswith",False)('ix86:'): # generated from line 108, col 1
                    arch = '%{ix86}'
                    req = VFSL([locals()]+SL+[globals(), builtin],"req",True)[5:]
                else: # generated from line 111, col 1
                    arch = ""
                #  end of checking
                if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 115, col 1
                    write(u'''%ifarch ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"arch",True) # u'$arch' on line 116, col 9
                    if _v is not None: write(_filter(_v, rawExpr=u'$arch')) # from line 116, col 9.
                    write(u'''
Requires:   ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 117, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 117, col 13.
                    write(u'''
%endif
''')
                else: # generated from line 119, col 1
                    write(u'''Requires:   ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 120, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 120, col 13.
                    write(u'''
''')
                #  each req
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RequiresPre"): # generated from line 124, col 1
            for req in VFSL([locals()]+SL+[globals(), builtin],"metadata.RequiresPre",True): # generated from line 125, col 1
                write(u'''Requires(pre): ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 126, col 16
                if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 126, col 16.
                write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RequiresPreUn"): # generated from line 129, col 1
            for req in VFSL([locals()]+SL+[globals(), builtin],"metadata.RequiresPreUn",True): # generated from line 130, col 1
                write(u'''Requires(preun): ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 131, col 18
                if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 131, col 18.
                write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RequiresPost"): # generated from line 134, col 1
            for req in VFSL([locals()]+SL+[globals(), builtin],"metadata.RequiresPost",True): # generated from line 135, col 1
                write(u'''Requires(post): ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 136, col 17
                if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 136, col 17.
                write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RequiresPostUn"): # generated from line 139, col 1
            for req in VFSL([locals()]+SL+[globals(), builtin],"metadata.RequiresPostUn",True): # generated from line 140, col 1
                write(u'''Requires(postun): ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 141, col 19
                if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 141, col 19.
                write(u'''
''')
        #  BuildRequires
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("PkgConfigBR"): # generated from line 145, col 1
            for br in VFSL([locals()]+SL+[globals(), builtin],"metadata.PkgConfigBR",True): # generated from line 146, col 1
                #  checking arch namespace prefix
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"br",True),"startswith",False)('arm:'): # generated from line 148, col 1
                    arch = '%{arm}'
                    br = VFSL([locals()]+SL+[globals(), builtin],"br",True)[4:]
                elif VFN(VFSL([locals()]+SL+[globals(), builtin],"br",True),"startswith",False)('ix86:'): # generated from line 151, col 1
                    arch = '%{ix86}'
                    br = VFSL([locals()]+SL+[globals(), builtin],"br",True)[5:]
                else: # generated from line 154, col 1
                    arch = ""
                #  end of checking
                if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 158, col 1
                    write(u'''%ifarch ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"arch",True) # u'$arch' on line 159, col 9
                    if _v is not None: write(_filter(_v, rawExpr=u'$arch')) # from line 159, col 9.
                    write(u'''
''')
                br_comps = VFN(VFSL([locals()]+SL+[globals(), builtin],"br",True),"split",False)()
                if VFSL([locals()]+SL+[globals(), builtin],"len",False)(VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)) > 1: # generated from line 162, col 1
                    write(u'''BuildRequires:  pkgconfig(''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)[0] # u'$br_comps[0]' on line 163, col 27
                    if _v is not None: write(_filter(_v, rawExpr=u'$br_comps[0]')) # from line 163, col 27.
                    write(u''')''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"br",True)[VFSL([locals()]+SL+[globals(), builtin],"len",False)(VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)[0]):] # u'$br[$len($br_comps[0]):]' on line 163, col 40
                    if _v is not None: write(_filter(_v, rawExpr=u'$br[$len($br_comps[0]):]')) # from line 163, col 40.
                    write(u'''
''')
                else: # generated from line 164, col 1
                    write(u'''BuildRequires:  pkgconfig(''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)[0] # u'$br_comps[0]' on line 165, col 27
                    if _v is not None: write(_filter(_v, rawExpr=u'$br_comps[0]')) # from line 165, col 27.
                    write(u''')
''')
                if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 167, col 1
                    write(u'''%endif
''')
                #  each br
        br_locale = ""
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("PkgBR"): # generated from line 173, col 1
            for br in VFSL([locals()]+SL+[globals(), builtin],"metadata.PkgBR",True): # generated from line 174, col 1
                #  checking arch namespace prefix
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"br",True),"startswith",False)('arm:'): # generated from line 176, col 1
                    arch = '%{arm}'
                    br = VFSL([locals()]+SL+[globals(), builtin],"br",True)[4:]
                elif VFN(VFSL([locals()]+SL+[globals(), builtin],"br",True),"startswith",False)('ix86:'): # generated from line 179, col 1
                    arch = '%{ix86}'
                    br = VFSL([locals()]+SL+[globals(), builtin],"br",True)[5:]
                else: # generated from line 182, col 1
                    arch = ""
                #  end of checking
                if VFSL([locals()]+SL+[globals(), builtin],"br",True) == 'intltool' and not VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("LocaleName") and not VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("NoAutoLocale"): # generated from line 186, col 1
                    br_locale = VFSL([locals()]+SL+[globals(), builtin],"metadata.Name",True)
                if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 189, col 1
                    write(u'''%ifarch ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"arch",True) # u'$arch' on line 190, col 9
                    if _v is not None: write(_filter(_v, rawExpr=u'$arch')) # from line 190, col 9.
                    write(u'''
BuildRequires:  ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"br",True) # u'$br' on line 191, col 17
                    if _v is not None: write(_filter(_v, rawExpr=u'$br')) # from line 191, col 17.
                    write(u'''
%endif
''')
                else: # generated from line 193, col 1
                    write(u'''BuildRequires:  ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"br",True) # u'$br' on line 194, col 17
                    if _v is not None: write(_filter(_v, rawExpr=u'$br')) # from line 194, col 17.
                    write(u'''
''')
                #  each br
        #  BuildConflicts
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("BuildConflicts"): # generated from line 199, col 1
            for bcfl in VFSL([locals()]+SL+[globals(), builtin],"metadata.BuildConflicts",True): # generated from line 200, col 1
                write(u'''BuildConflicts: ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"bcfl",True) # u'$bcfl' on line 201, col 17
                if _v is not None: write(_filter(_v, rawExpr=u'$bcfl')) # from line 201, col 17.
                write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RunFdupes"): # generated from line 204, col 1
            write(u'''BuildRequires:  fdupes
''')
        if 'NoAutoProv' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 207, col 1
            write(u'''AutoProv: 0
''')
        #  Provides
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Provides"): # generated from line 211, col 1
            for prd in VFSL([locals()]+SL+[globals(), builtin],"metadata.Provides",True): # generated from line 212, col 1
                write(u'''Provides:   ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"prd",True) # u'$prd' on line 213, col 13
                if _v is not None: write(_filter(_v, rawExpr=u'$prd')) # from line 213, col 13.
                write(u'''
''')
        #  Conflicts
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Conflicts"): # generated from line 217, col 1
            for cfl in VFSL([locals()]+SL+[globals(), builtin],"metadata.Conflicts",True): # generated from line 218, col 1
                write(u'''Conflicts:   ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"cfl",True) # u'$cfl' on line 219, col 14
                if _v is not None: write(_filter(_v, rawExpr=u'$cfl')) # from line 219, col 14.
                write(u'''
''')
        #  Obsoletes
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Obsoletes"): # generated from line 223, col 1
            for obs in VFSL([locals()]+SL+[globals(), builtin],"metadata.Obsoletes",True): # generated from line 224, col 1
                write(u'''Obsoletes:   ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"obs",True) # u'$obs' on line 225, col 14
                if _v is not None: write(_filter(_v, rawExpr=u'$obs')) # from line 225, col 14.
                write(u'''
''')
        if 'SupportOtherDistros' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 228, col 1
            write(u'''BuildRoot:  %{_tmppath}/%{name}-%{version}-build
''')
        write(u'''

%description
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Description"): # generated from line 234, col 1
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Description",True) # u'${metadata.Description}' on line 235, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Description}')) # from line 235, col 1.
            write(u'''
''')
        else: # generated from line 236, col 1
            write(u'''Description: %{summary}
''')
        write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("AutoSubPackages"): # generated from line 240, col 1
            for sp in VFSL([locals()]+SL+[globals(), builtin],"metadata.AutoSubPackages",True): # generated from line 241, col 1
                write(u'''%package ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"sp",True) # u'$sp' on line 242, col 10
                if _v is not None: write(_filter(_v, rawExpr=u'$sp')) # from line 242, col 10.
                write(u'''
Summary:    Development files for %{name}
Group:      Development/Libraries
Requires:   %{name} = ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"auto_depend",True) # u'$auto_depend' on line 245, col 23
                if _v is not None: write(_filter(_v, rawExpr=u'$auto_depend')) # from line 245, col 23.
                write(u'''
%description ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"sp",True) # u'$sp' on line 246, col 14
                if _v is not None: write(_filter(_v, rawExpr=u'$sp')) # from line 246, col 14.
                write(u'''
Development files for %{name}

''')
        write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("SubPackages"): # generated from line 252, col 1
            for sp in VFSL([locals()]+SL+[globals(), builtin],"metadata.SubPackages",True): # generated from line 253, col 1
                sub_extra = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra",True),"subpkgs",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("AsWholeName"): # generated from line 255, col 1
                    write(u'''%package -n ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 256, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 256, col 13.
                    write(u'''
''')
                else: # generated from line 257, col 1
                    write(u'''%package ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 258, col 10
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 258, col 10.
                    write(u'''
''')
                write(u'''Summary:    ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Summary",True) # u'$sp.Summary' on line 260, col 13
                if _v is not None: write(_filter(_v, rawExpr=u'$sp.Summary')) # from line 260, col 13.
                write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("License"): # generated from line 261, col 1
                    write(u'''License:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.License",True) # u'$sp.License' on line 262, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.License')) # from line 262, col 13.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Group"): # generated from line 264, col 1
                    write(u'''Group:      ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Group",True) # u'$sp.Group' on line 265, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Group')) # from line 265, col 13.
                    write(u'''
''')
                else: # generated from line 266, col 1
                    write(u'''Group:      ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.Group",True) # u'${metadata.Group}' on line 267, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'${metadata.Group}')) # from line 267, col 13.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Version"): # generated from line 269, col 1
                    write(u'''Version:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Version",True) # u'$sp.Version' on line 270, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Version')) # from line 270, col 13.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Release"): # generated from line 272, col 1
                    write(u'''Release:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Release",True) # u'$sp.Release' on line 273, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Release')) # from line 273, col 13.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Epoch"): # generated from line 275, col 1
                    write(u'''Epoch:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Epoch",True) # u'$sp.Epoch' on line 276, col 11
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Epoch')) # from line 276, col 11.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("URL"): # generated from line 278, col 1
                    write(u'''URL:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.URL",True) # u'$sp.URL' on line 279, col 9
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.URL')) # from line 279, col 9.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("BuildArch"): # generated from line 281, col 1
                    write(u'''BuildArch:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.BuildArch",True) # u'$sp.BuildArch' on line 282, col 15
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.BuildArch')) # from line 282, col 15.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Prefix"): # generated from line 284, col 1
                    write(u'''Prefix:    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Prefix",True) # u'$sp.Prefix' on line 285, col 12
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Prefix')) # from line 285, col 12.
                    write(u'''
''')
                if 'NoAutoReq' in VFSL([locals()]+SL+[globals(), builtin],"sp",True): # generated from line 287, col 1
                    write(u'''AutoReq:    0
''')
                if 'NoAutoProv' in VFSL([locals()]+SL+[globals(), builtin],"sp",True): # generated from line 290, col 1
                    write(u'''AutoProv:    0
''')
                if 'NoAutoReqProv' in VFSL([locals()]+SL+[globals(), builtin],"sp",True): # generated from line 293, col 1
                    write(u'''AutoReqProv:    0
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("AutoDepend") and not VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("NoFiles"): # generated from line 296, col 1
                    write(u'''Requires:   %{name} = ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"auto_depend",True) # u'$auto_depend' on line 297, col 23
                    if _v is not None: write(_filter(_v, rawExpr=u'$auto_depend')) # from line 297, col 23.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Requires"): # generated from line 299, col 1
                    for req in VFSL([locals()]+SL+[globals(), builtin],"sp.Requires",True): # generated from line 300, col 1
                        #  checking arch namespace prefix
                        if VFN(VFSL([locals()]+SL+[globals(), builtin],"req",True),"startswith",False)('arm:'): # generated from line 302, col 1
                            arch = '%{arm}'
                            req = VFSL([locals()]+SL+[globals(), builtin],"req",True)[4:]
                        elif VFN(VFSL([locals()]+SL+[globals(), builtin],"req",True),"startswith",False)('ix86:'): # generated from line 305, col 1
                            arch = '%{ix86}'
                            req = VFSL([locals()]+SL+[globals(), builtin],"req",True)[5:]
                        else: # generated from line 308, col 1
                            arch = ""
                        #  end of checking
                        if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 312, col 1
                            write(u'''%ifarch ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"arch",True) # u'$arch' on line 313, col 9
                            if _v is not None: write(_filter(_v, rawExpr=u'$arch')) # from line 313, col 9.
                            write(u'''
Requires:   ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 314, col 13
                            if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 314, col 13.
                            write(u'''
%endif
''')
                        else: # generated from line 316, col 1
                            write(u'''Requires:   ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 317, col 13
                            if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 317, col 13.
                            write(u'''
''')
                        #  each req
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("RequiresPre"): # generated from line 321, col 1
                    for req in VFSL([locals()]+SL+[globals(), builtin],"sp.RequiresPre",True): # generated from line 322, col 1
                        write(u'''Requires(pre): ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 323, col 16
                        if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 323, col 16.
                        write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("RequiresPreUn"): # generated from line 326, col 1
                    for req in VFSL([locals()]+SL+[globals(), builtin],"sp.RequiresPreUn",True): # generated from line 327, col 1
                        write(u'''Requires(preun): ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 328, col 18
                        if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 328, col 18.
                        write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("RequiresPost"): # generated from line 331, col 1
                    for req in VFSL([locals()]+SL+[globals(), builtin],"sp.RequiresPost",True): # generated from line 332, col 1
                        write(u'''Requires(post): ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 333, col 17
                        if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 333, col 17.
                        write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("RequiresPostUn"): # generated from line 336, col 1
                    for req in VFSL([locals()]+SL+[globals(), builtin],"sp.RequiresPostUn",True): # generated from line 337, col 1
                        write(u'''Requires(postun): ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"req",True) # u'$req' on line 338, col 19
                        if _v is not None: write(_filter(_v, rawExpr=u'$req')) # from line 338, col 19.
                        write(u'''
''')
                #  Provides
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Provides"): # generated from line 342, col 1
                    for prd in VFSL([locals()]+SL+[globals(), builtin],"sp.Provides",True): # generated from line 343, col 1
                        write(u'''Provides:   ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"prd",True) # u'$prd' on line 344, col 13
                        if _v is not None: write(_filter(_v, rawExpr=u'$prd')) # from line 344, col 13.
                        write(u'''
''')
                #  Conflicts
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Conflicts"): # generated from line 348, col 1
                    for cfl in VFSL([locals()]+SL+[globals(), builtin],"sp.Conflicts",True): # generated from line 349, col 1
                        write(u'''Conflicts:   ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"cfl",True) # u'$cfl' on line 350, col 14
                        if _v is not None: write(_filter(_v, rawExpr=u'$cfl')) # from line 350, col 14.
                        write(u'''
''')
                #  Obsoletes
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Obsoletes"): # generated from line 354, col 1
                    for obs in VFSL([locals()]+SL+[globals(), builtin],"sp.Obsoletes",True): # generated from line 355, col 1
                        write(u'''Obsoletes:   ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"obs",True) # u'$obs' on line 356, col 14
                        if _v is not None: write(_filter(_v, rawExpr=u'$obs')) # from line 356, col 14.
                        write(u'''
''')
                #  BR
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("PkgBR"): # generated from line 360, col 1
                    for br in VFSL([locals()]+SL+[globals(), builtin],"sp.PkgBR",True): # generated from line 361, col 1
                        #  checking arch namespace prefix
                        if VFN(VFSL([locals()]+SL+[globals(), builtin],"br",True),"startswith",False)('arm:'): # generated from line 363, col 1
                            arch = '%{arm}'
                            br = VFSL([locals()]+SL+[globals(), builtin],"br",True)[4:]
                        elif VFN(VFSL([locals()]+SL+[globals(), builtin],"br",True),"startswith",False)('ix86:'): # generated from line 366, col 1
                            arch = '%{ix86}'
                            br = VFSL([locals()]+SL+[globals(), builtin],"br",True)[5:]
                        else: # generated from line 369, col 1
                            arch = ""
                        #  end of checking
                        if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 373, col 1
                            write(u'''%ifarch ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"arch",True) # u'$arch' on line 374, col 9
                            if _v is not None: write(_filter(_v, rawExpr=u'$arch')) # from line 374, col 9.
                            write(u'''
BuildRequires:   ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"br",True) # u'$br' on line 375, col 18
                            if _v is not None: write(_filter(_v, rawExpr=u'$br')) # from line 375, col 18.
                            write(u'''
%endif
''')
                        else: # generated from line 377, col 1
                            write(u'''BuildRequires:   ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"br",True) # u'$br' on line 378, col 18
                            if _v is not None: write(_filter(_v, rawExpr=u'$br')) # from line 378, col 18.
                            write(u'''
''')
                        #  each br
                #  PkgConfigBR
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("PkgConfigBR"): # generated from line 383, col 1
                    for br in VFSL([locals()]+SL+[globals(), builtin],"sp.PkgConfigBR",True): # generated from line 384, col 1
                        #  checking arch namespace prefix
                        if VFN(VFSL([locals()]+SL+[globals(), builtin],"br",True),"startswith",False)('arm:'): # generated from line 386, col 1
                            arch = '%{arm}'
                            br = VFSL([locals()]+SL+[globals(), builtin],"br",True)[4:]
                        elif VFN(VFSL([locals()]+SL+[globals(), builtin],"br",True),"startswith",False)('ix86:'): # generated from line 389, col 1
                            arch = '%{ix86}'
                            br = VFSL([locals()]+SL+[globals(), builtin],"br",True)[5:]
                        else: # generated from line 392, col 1
                            arch = ""
                        #  end of checking
                        if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 396, col 1
                            write(u'''%ifarch ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"arch",True) # u'$arch' on line 397, col 9
                            if _v is not None: write(_filter(_v, rawExpr=u'$arch')) # from line 397, col 9.
                            write(u'''
''')
                        br_comps = VFN(VFSL([locals()]+SL+[globals(), builtin],"br",True),"split",False)()
                        if VFSL([locals()]+SL+[globals(), builtin],"len",False)(VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)) > 1: # generated from line 400, col 1
                            write(u'''BuildRequires:  pkgconfig(''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)[0] # u'$br_comps[0]' on line 401, col 27
                            if _v is not None: write(_filter(_v, rawExpr=u'$br_comps[0]')) # from line 401, col 27.
                            write(u''')''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"br",True)[VFSL([locals()]+SL+[globals(), builtin],"len",False)(VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)[0]):] # u'$br[$len($br_comps[0]):]' on line 401, col 40
                            if _v is not None: write(_filter(_v, rawExpr=u'$br[$len($br_comps[0]):]')) # from line 401, col 40.
                            write(u'''
''')
                        else: # generated from line 402, col 1
                            write(u'''BuildRequires:  pkgconfig(''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"br_comps",True)[0] # u'$br_comps[0]' on line 403, col 27
                            if _v is not None: write(_filter(_v, rawExpr=u'$br_comps[0]')) # from line 403, col 27.
                            write(u''')
''')
                        if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 405, col 1
                            write(u'''%endif
''')
                        #  each br
                #  BuildConflicts
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("BuildConflicts"): # generated from line 411, col 1
                    for bcfl in VFSL([locals()]+SL+[globals(), builtin],"sp.BuildConflicts",True): # generated from line 412, col 1
                        write(u'''BuildConflicts: ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"bcfl",True) # u'$bcfl' on line 413, col 17
                        if _v is not None: write(_filter(_v, rawExpr=u'$bcfl')) # from line 413, col 17.
                        write(u'''
''')
                write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("AsWholeName"): # generated from line 417, col 1
                    write(u'''%description -n ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 418, col 17
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 418, col 17.
                    write(u'''
''')
                else: # generated from line 419, col 1
                    write(u'''%description ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 420, col 14
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 420, col 14.
                    write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)('Description'): # generated from line 422, col 1
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Description",True) # u'$sp.Description' on line 423, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.Description')) # from line 423, col 1.
                    write(u'''
''')
                else: # generated from line 424, col 1
                    write(u'''Description: %{summary}
''')
                write(u'''
''')
        write(u'''
''')
        # ########################## prep scripts
        write(u'''%prep
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Sources"): # generated from line 433, col 1
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("NoSetup"): # generated from line 434, col 1
                write(u'''# No setup
''')
            elif VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("SetupOptions"): # generated from line 436, col 1
                write(u'''%setup ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.SetupOptions",True) # u'$metadata.SetupOptions' on line 437, col 8
                if _v is not None: write(_filter(_v, rawExpr=u'$metadata.SetupOptions')) # from line 437, col 8.
                write(u'''
''')
            else: # generated from line 438, col 1
                write(u'''%setup -q -n ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.SourcePrefix",True) # u'$metadata.SourcePrefix' on line 439, col 14
                if _v is not None: write(_filter(_v, rawExpr=u'$metadata.SourcePrefix')) # from line 439, col 14.
                write(u'''
''')
            write(u'''
''')
            #  has Sources
        #  Applying patches
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Patches"): # generated from line 444, col 1
            idx = 0
            for patch in VFSL([locals()]+SL+[globals(), builtin],"metadata.Patches",True): # generated from line 446, col 1
                #  checking arch namespace prefix
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"patch",True),"startswith",False)('arm:'): # generated from line 448, col 1
                    arch = '%{arm}'
                    patch = VFSL([locals()]+SL+[globals(), builtin],"patch",True)[4:]
                elif VFN(VFSL([locals()]+SL+[globals(), builtin],"patch",True),"startswith",False)('ix86:'): # generated from line 451, col 1
                    arch = '%{ix86}'
                    patch = VFSL([locals()]+SL+[globals(), builtin],"patch",True)[5:]
                else: # generated from line 454, col 1
                    arch = ""
                #  end of checking
                if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 458, col 1
                    write(u'''%ifarch ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"arch",True) # u'$arch' on line 459, col 9
                    if _v is not None: write(_filter(_v, rawExpr=u'$arch')) # from line 459, col 9.
                    write(u'''
''')
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"PatchCmts",True)[VFSL([locals()]+SL+[globals(), builtin],"idx",True)] # u'$metadata.PatchCmts[$idx]' on line 461, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$metadata.PatchCmts[$idx]')) # from line 461, col 1.
                write(u'''
''')
                if 'PatchOpts' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 462, col 1
                    write(u'''%patch''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"idx",True) # u'${idx}' on line 463, col 7
                    if _v is not None: write(_filter(_v, rawExpr=u'${idx}')) # from line 463, col 7.
                    write(u''' ''')
                    _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"PatchOpts",True)[VFSL([locals()]+SL+[globals(), builtin],"idx",True)] # u'$metadata.PatchOpts[$idx]' on line 463, col 14
                    if _v is not None: write(_filter(_v, rawExpr=u'$metadata.PatchOpts[$idx]')) # from line 463, col 14.
                    write(u'''
''')
                else: # generated from line 464, col 1
                    write(u'''%patch''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"idx",True) # u'${idx}' on line 465, col 7
                    if _v is not None: write(_filter(_v, rawExpr=u'${idx}')) # from line 465, col 7.
                    write(u''' -p1
''')
                if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 467, col 1
                    write(u'''%endif
''')
                idx = VFSL([locals()]+SL+[globals(), builtin],"idx",True) + 1
        write(u'''# >> setup
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("setup") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.setup",True),"has_key",False)("main"): # generated from line 474, col 1
            _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.setup.main",True)) # u'$str_newline.join($extra.content.setup.main)' on line 475, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.setup.main)')) # from line 475, col 1.
            write(u'''
''')
        write(u'''# << setup

''')
        # ########################## build scripts
        write(u'''%build
''')
        if not VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)('UseAsNeeded'): # generated from line 481, col 1
            write(u'''unset LD_AS_NEEDED
''')
        write(u'''# >> build pre
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("build") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.build",True),"has_key",False)("pre"): # generated from line 485, col 1
            _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.build.pre",True)) # u'$str_newline.join($extra.content.build.pre)' on line 486, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.build.pre)')) # from line 486, col 1.
            write(u'''
''')
        write(u'''# << build pre

''')
        if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'python': # generated from line 491, col 1
            write(u'''CFLAGS="$RPM_OPT_FLAGS" %{__python} setup.py build
''')
        elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'qmake': # generated from line 493, col 1
            Configure = 'none'
            if 'SupportOtherDistros' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 495, col 1
                write(u'''%if 0%{?moblin_version}
%qmake ''')
                if 'QMakeOptions' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 498, col 1
                    write(u''' \\
''')
                else: # generated from line 500, col 1
                    write(u'''
''')
                write(u'''%else
qmake -makefile -nocache \\
  "QMAKE_CFLAGS_RELEASE=${CFLAGS:-%optflags}" \\
  "QMAKE_CFLAGS_DEBUG=${CFLAGS:-%optflags}" \\
  "QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS:-%optflags}" \\
  "QMAKE_CXXFLAGS_DEBUG=${CXXFLAGS:-%optflags}" \\
  QMAKE_STRIP=: \\
  PREFIX=%{_prefix} ''')
                if 'QMakeOptions' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 511, col 1
                    write(u''' \\
''')
                else: # generated from line 513, col 1
                    write(u'''
''')
                write(u'''%endif
''')
            else: # generated from line 517, col 1
                write(u'''%qmake ''')
                if 'QMakeOptions' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 519, col 1
                    write(u''' \\
''')
                else: # generated from line 521, col 1
                    write(u'''
''')
            if 'QMakeOptions' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 525, col 1
                length = len(VFSL([locals()]+SL+[globals(), builtin],"metadata.QMakeOptions",True))
                idx = 1
                for opt in VFSL([locals()]+SL+[globals(), builtin],"metadata.QMakeOptions",True): # generated from line 528, col 1
                    #  checking arch namespace prefix
                    if VFN(VFSL([locals()]+SL+[globals(), builtin],"opt",True),"startswith",False)('arm:'): # generated from line 530, col 1
                        arch = '%{arm}'
                        opt = VFSL([locals()]+SL+[globals(), builtin],"opt",True)[4:]
                    elif VFN(VFSL([locals()]+SL+[globals(), builtin],"opt",True),"startswith",False)('ix86:'): # generated from line 533, col 1
                        arch = '%{ix86}'
                        opt = VFSL([locals()]+SL+[globals(), builtin],"opt",True)[5:]
                    else: # generated from line 536, col 1
                        arch = ""
                    #  end of checking
                    if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 540, col 1
                        write(u'''%ifarch ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"arch",True) # u'$arch' on line 541, col 9
                        if _v is not None: write(_filter(_v, rawExpr=u'$arch')) # from line 541, col 9.
                        write(u'''
''')
                    write(u'''    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"opt",True) # u'$opt' on line 543, col 5
                    if _v is not None: write(_filter(_v, rawExpr=u'$opt')) # from line 543, col 5.
                    if VFSL([locals()]+SL+[globals(), builtin],"idx",True) == VFSL([locals()]+SL+[globals(), builtin],"length",True): # generated from line 544, col 1
                        write(u'''
''')
                    else: # generated from line 546, col 1
                        write(u''' \\
''')
                    if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 549, col 1
                        write(u'''%endif
''')
                    idx = VFSL([locals()]+SL+[globals(), builtin],"idx",True) + 1
                #  QMakeOptions
            write(u'''
make %{?jobs:-j%jobs}
''')
        elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'perl': # generated from line 557, col 1
            write(u'''if test -f Makefile.PL; then
%{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?jobs:-j%jobs}
else
%{__perl} Build.PL  --installdirs vendor
./Build
fi
''')
        else: # generated from line 565, col 1
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)('Configure'): # generated from line 567, col 1
                Configure = VFSL([locals()]+SL+[globals(), builtin],"metadata.Configure",True)
            else: # generated from line 570, col 1
                #  default
                if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'cmake': # generated from line 572, col 1
                    Configure = 'cmake'
                else: # generated from line 574, col 1
                    Configure = 'configure'
            if VFSL([locals()]+SL+[globals(), builtin],"Configure",True) == 'autogen': # generated from line 579, col 1
                write(u'''%autogen ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"cfgstatic",True) # u'$cfgstatic' on line 580, col 10
                if _v is not None: write(_filter(_v, rawExpr=u'$cfgstatic')) # from line 580, col 10.
            elif VFSL([locals()]+SL+[globals(), builtin],"Configure",True) == 'cmake': # generated from line 581, col 1
                write(u'''mkdir meego-build
cd meego-build
cmake .. ''')
            elif VFSL([locals()]+SL+[globals(), builtin],"Configure",True) == 'configure': # generated from line 585, col 1
                write(u'''%configure ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"cfgstatic",True) # u'$cfgstatic' on line 586, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'$cfgstatic')) # from line 586, col 12.
            elif VFSL([locals()]+SL+[globals(), builtin],"Configure",True) == 'reconfigure': # generated from line 587, col 1
                write(u'''%reconfigure ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"cfgstatic",True) # u'$cfgstatic' on line 588, col 14
                if _v is not None: write(_filter(_v, rawExpr=u'$cfgstatic')) # from line 588, col 14.
            elif VFSL([locals()]+SL+[globals(), builtin],"Configure",True) == 'cmake': # generated from line 589, col 1
                write(u'''%reconfigure ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"cfgstatic",True) # u'$cfgstatic' on line 590, col 14
                if _v is not None: write(_filter(_v, rawExpr=u'$cfgstatic')) # from line 590, col 14.
            #  any other values fall thru to 'noconfigure'
            if ( VFSL([locals()]+SL+[globals(), builtin],"Configure",True) != 'noconfigure' or VFSL([locals()]+SL+[globals(), builtin],"Configure",True) != 'none' ) and VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("ConfigOptions"): # generated from line 593, col 1
                write(u''' \\
''')
                length = len(VFSL([locals()]+SL+[globals(), builtin],"metadata.ConfigOptions",True))
                idx = 1
                for opt in VFSL([locals()]+SL+[globals(), builtin],"metadata.ConfigOptions",True): # generated from line 597, col 1
                    #  checking arch namespace prefix
                    if VFN(VFSL([locals()]+SL+[globals(), builtin],"opt",True),"startswith",False)('arm:'): # generated from line 599, col 1
                        arch = '%{arm}'
                        opt = VFSL([locals()]+SL+[globals(), builtin],"opt",True)[4:]
                    elif VFN(VFSL([locals()]+SL+[globals(), builtin],"opt",True),"startswith",False)('ix86:'): # generated from line 602, col 1
                        arch = '%{ix86}'
                        opt = VFSL([locals()]+SL+[globals(), builtin],"opt",True)[5:]
                    else: # generated from line 605, col 1
                        arch = ""
                    #  end of checking
                    if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 609, col 1
                        write(u'''%ifarch ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"arch",True) # u'$arch' on line 610, col 9
                        if _v is not None: write(_filter(_v, rawExpr=u'$arch')) # from line 610, col 9.
                        write(u'''
''')
                    write(u'''    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"opt",True) # u'$opt' on line 612, col 5
                    if _v is not None: write(_filter(_v, rawExpr=u'$opt')) # from line 612, col 5.
                    if VFSL([locals()]+SL+[globals(), builtin],"idx",True) == VFSL([locals()]+SL+[globals(), builtin],"length",True): # generated from line 613, col 1
                        write(u'''
''')
                    else: # generated from line 615, col 1
                        write(u''' \\
''')
                    if VFSL([locals()]+SL+[globals(), builtin],"arch",True): # generated from line 618, col 1
                        write(u'''%endif
''')
                    idx = VFSL([locals()]+SL+[globals(), builtin],"idx",True) + 1
                #  ConfigOptions
            write(u'''
''')
            if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'make' or VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'cmake': # generated from line 625, col 1
                write(u'''make %{?jobs:-j%jobs}
''')
            elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'single-make': # generated from line 627, col 1
                write(u'''make
''')
            elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) != 'no-make' and VFSL([locals()]+SL+[globals(), builtin],"Builder",True) != 'none' and VFSL([locals()]+SL+[globals(), builtin],"Builder",True) != 'no-builder': # generated from line 629, col 1
                _v = VFSL([locals()]+SL+[globals(), builtin],"Builder",True) # u'$Builder' on line 630, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$Builder')) # from line 630, col 1.
                write(u'''
''')
            #  Builder == python
        write(u'''
# >> build post
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("build") and  VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.build",True),"has_key",False)("post"): # generated from line 636, col 1
            _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.build.post",True)) # u'$str_newline.join($extra.content.build.post)' on line 637, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.build.post)')) # from line 637, col 1.
            write(u'''
''')
        write(u'''# << build post
''')
        # ########################## installation scripts
        write(u'''%install
''')
        if 'SupportOtherDistros' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 642, col 1
            write(u'''rm -rf $RPM_BUILD_ROOT
''')
        else: # generated from line 644, col 1
            write(u'''rm -rf %{buildroot}
''')
        write(u'''# >> install pre
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("install") and  VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.install",True),"has_key",False)("pre"): # generated from line 648, col 1
            _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.install.pre",True)) # u'$str_newline.join($extra.content.install.pre)' on line 649, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.install.pre)')) # from line 649, col 1.
            write(u'''
''')
        write(u'''# << install pre
''')
        if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'python': # generated from line 652, col 1
            if 'SupportOtherDistros' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 653, col 1
                write(u'''%if 0%{?suse_version}
%{__python} setup.py install --root=$RPM_BUILD_ROOT --prefix=%{_prefix}
%else
%{__python} setup.py install --root=$RPM_BUILD_ROOT -O1
%endif
''')
            else: # generated from line 659, col 1
                write(u'''%{__python} setup.py install --root=%{buildroot} -O1
''')
        elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'perl': # generated from line 662, col 1
            write(u"""if test -f Makefile.PL; then
make pure_install PERL_INSTALL_ROOT=%{buildroot}
else
./Build install --installdirs vendor
fi
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} 2>/dev/null ';'
find %{buildroot} -type f -name '*.bs' -empty -exec rm -f {} ';'
%{_fixperms} %{buildroot}/*
""")
        elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'qmake': # generated from line 672, col 1
            if 'SupportOtherDistros' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 673, col 1
                write(u'''%if 0%{?moblin_version}
%qmake_install
%else
%makeinstall
%endif
''')
            else: # generated from line 679, col 1
                write(u'''%qmake_install
''')
        elif VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'make' or VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'single-make' or VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'cmake': # generated from line 682, col 1
            if 'SupportOtherDistros' in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 683, col 1
                write(u'''%if 0%{?moblin_version}
%make_install
%else
%makeinstall
%endif
''')
            else: # generated from line 689, col 1
                if VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'cmake': # generated from line 690, col 1
                    write(u'''cd meego-build
''')
                write(u'''%make_install
''')
            #  of Builder==???
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("ExtraInstall"): # generated from line 696, col 1
            _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.ExtraInstall",True) # u'$metadata.ExtraInstall' on line 697, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$metadata.ExtraInstall')) # from line 697, col 1.
            write(u'''
''')
        write(u'''
# >> install post
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("install") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.install",True),"has_key",False)("post"): # generated from line 701, col 1
            _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.install.post",True)) # u'$str_newline.join($extra.content.install.post)' on line 702, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.install.post)')) # from line 702, col 1.
            write(u'''
''')
        write(u'''# << install post
''')
        if VFSL([locals()]+SL+[globals(), builtin],"extra.Desktop",True): # generated from line 705, col 1
            write(u'''desktop-file-install --delete-original       \\
  --dir %{buildroot}%{_datadir}/applications             \\
   %{buildroot}%{_datadir}/applications/*.desktop
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("LocaleName"): # generated from line 710, col 1
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("LocaleOptions"): # generated from line 711, col 1
                localeopt_str = VFSL([locals()]+SL+[globals(), builtin],"metadata",True)["LocaleOptions"]
                write(u'''%find_lang ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.LocaleName",True) # u'${metadata.LocaleName}' on line 713, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'${metadata.LocaleName}')) # from line 713, col 12.
                write(u''' ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"localeopt_str",True) # u'$localeopt_str' on line 713, col 35
                if _v is not None: write(_filter(_v, rawExpr=u'$localeopt_str')) # from line 713, col 35.
                write(u'''
''')
            else: # generated from line 714, col 1
                write(u'''%find_lang ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.LocaleName",True) # u'${metadata.LocaleName}' on line 715, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'${metadata.LocaleName}')) # from line 715, col 12.
                write(u'''
''')
        elif VFSL([locals()]+SL+[globals(), builtin],"br_locale",True) != "": # generated from line 717, col 1
            write(u'''%find_lang ''')
            _v = VFSL([locals()]+SL+[globals(), builtin],"br_locale",True) # u'$br_locale' on line 718, col 12
            if _v is not None: write(_filter(_v, rawExpr=u'$br_locale')) # from line 718, col 12.
            write(u'''
''')
        # ########################## run fdupes
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("RunFdupes"): # generated from line 721, col 1
            for fditem in VFSL([locals()]+SL+[globals(), builtin],"metadata.RunFdupes",True): # generated from line 722, col 1
                write(u'''%fdupes  %{buildroot}/''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"fditem",True) # u'$fditem' on line 723, col 23
                if _v is not None: write(_filter(_v, rawExpr=u'$fditem')) # from line 723, col 23.
                write(u'''
''')
        # ########################## optional check scripts
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Check"): # generated from line 727, col 1
            write(u'''%check
# >> check
''')
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("check"): # generated from line 730, col 1
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.check.main",True)) # u'$str_newline.join($extra.content.check.main)' on line 731, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.check.main)')) # from line 731, col 1.
                write(u'''
''')
            else: # generated from line 732, col 1
                if  VFSL([locals()]+SL+[globals(), builtin],"Builder",True) == 'perl': # generated from line 733, col 1
                    write(u'''if test -f Makefile.PL; then
make test
else
./Build test
fi
''')
                else: # generated from line 739, col 1
                    write(u'''make check
''')
            write(u'''# << check
''')
        write(u'''
''')
        # ########################## Pre
        has_extra_pre = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("pre") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.pre",True),"has_key",False)("main")
        if VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_pre",True): # generated from line 748, col 1
            write(u'''%pre
''')
            #  -Schema
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True): # generated from line 751, col 1
                write(u'''if [ "$1" -gt 1 ]; then
''')
                for schema in VFSL([locals()]+SL+[globals(), builtin],"extra.Schemas",True): # generated from line 753, col 1
                    write(u'''  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule \\
    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"schema",True) # u'$schema' on line 756, col 5
                    if _v is not None: write(_filter(_v, rawExpr=u'$schema')) # from line 756, col 5.
                    write(u''' \\
    > /dev/null || :
''')
                write(u'''fi
''')
            #  -Extra pre
            if VFSL([locals()]+SL+[globals(), builtin],"has_extra_pre",True): # generated from line 762, col 1
                write(u'''# >> pre
''')
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.pre.main",True)) # u'$str_newline.join($extra.content.pre.main)' on line 764, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.pre.main)')) # from line 764, col 1.
                write(u'''
# << pre
''')
        write(u'''
''')
        # ########################## PreUn
        has_extra_preun = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("preun") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.preun",True),"has_key",False)("main")
        if VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_preun",True): # generated from line 771, col 1
            write(u'''%preun
''')
            #  -Schema
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True): # generated from line 774, col 1
                write(u'''if [ "$1" -eq 0 ]; then
''')
                for schema in VFSL([locals()]+SL+[globals(), builtin],"extra.Schemas",True): # generated from line 776, col 1
                    write(u'''  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule \\
    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"schema",True) # u'$schema' on line 779, col 5
                    if _v is not None: write(_filter(_v, rawExpr=u'$schema')) # from line 779, col 5.
                    write(u''' \\
    > /dev/null || :
''')
                write(u'''fi
''')
            #  -Extra preun
            if VFSL([locals()]+SL+[globals(), builtin],"has_extra_preun",True): # generated from line 785, col 1
                write(u'''# >> preun
''')
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.preun.main",True)) # u'$str_newline.join($extra.content.preun.main)' on line 787, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.preun.main)')) # from line 787, col 1.
                write(u'''
# << preun
''')
        write(u'''
''')
        # ########################## Post
        has_extra_post = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("post") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.post",True),"has_key",False)("main") and VFSL([locals()]+SL+[globals(), builtin],"extra.content.post.main",True)
        if VFSL([locals()]+SL+[globals(), builtin],"extra.Lib",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_post",True): # generated from line 794, col 1
            only_Lib = not (VFSL([locals()]+SL+[globals(), builtin],"extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_post",True))
            if VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 796, col 1
                write(u'''%post -p /sbin/ldconfig
''')
            else: # generated from line 798, col 1
                write(u'''%post
''')
            #  -Lib
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Lib",True) and not VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 802, col 1
                write(u'''/sbin/ldconfig
''')
            #  -Schema
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Schema",True): # generated from line 806, col 1
                for schema in VFSL([locals()]+SL+[globals(), builtin],"extra.Schemas",True): # generated from line 807, col 1
                    write(u'''export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule \\
    ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"schema",True) # u'$schema' on line 810, col 5
                    if _v is not None: write(_filter(_v, rawExpr=u'$schema')) # from line 810, col 5.
                    write(u'''  > /dev/null || :
''')
            #  -Info
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Info",True): # generated from line 814, col 1
                for inf in VFSL([locals()]+SL+[globals(), builtin],"extra.Infos",True): # generated from line 815, col 1
                    write(u'''%install_info --info-dir=%_infodir ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"inf",True) # u'$inf' on line 816, col 36
                    if _v is not None: write(_filter(_v, rawExpr=u'$inf')) # from line 816, col 36.
                    write(u'''
''')
            #  -Icon
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Icon",True): # generated from line 820, col 1
                write(u'''/bin/touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache \\
  --quiet %{_datadir}/icons/hicolor 2> /dev/null|| :
''')
            #  -DesktopDB
            if VFSL([locals()]+SL+[globals(), builtin],"extra.DesktopDB",True): # generated from line 826, col 1
                write(u'''update-desktop-database %{_datadir}/applications &> /dev/null || :
''')
            #  -Extra Post Script
            if VFSL([locals()]+SL+[globals(), builtin],"has_extra_post",True): # generated from line 830, col 1
                write(u'''# >> post
''')
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.post.main",True)) # u'$str_newline.join($extra.content.post.main)' on line 832, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.post.main)')) # from line 832, col 1.
                write(u'''
# << post
''')
            #  need post
        write(u'''
''')
        # ########################## PostUn
        has_extra_postun = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("postun") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.postun",True),"has_key",False)("main") and VFSL([locals()]+SL+[globals(), builtin],"extra.content.postun.main",True)
        if VFSL([locals()]+SL+[globals(), builtin],"extra.Lib",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_postun",True): # generated from line 839, col 1
            only_Lib = not (VFSL([locals()]+SL+[globals(), builtin],"extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_postun",True))
            if VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 841, col 1
                write(u'''%postun -p /sbin/ldconfig
''')
            else: # generated from line 843, col 1
                write(u'''%postun
''')
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Lib",True) and not VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 846, col 1
                write(u'''/sbin/ldconfig
''')
            #  -Info
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Info",True): # generated from line 850, col 1
                write(u'''if [ $1 = 0 ] ;then
''')
                for inf in VFSL([locals()]+SL+[globals(), builtin],"extra.Infos",True): # generated from line 852, col 1
                    write(u'''%install_info_delete --info-dir=%{_infodir} ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"inf",True) # u'$inf' on line 853, col 45
                    if _v is not None: write(_filter(_v, rawExpr=u'$inf')) # from line 853, col 45.
                    write(u'''
''')
                write(u'''fi
''')
            #  -Icon
            if VFSL([locals()]+SL+[globals(), builtin],"extra.Icon",True): # generated from line 858, col 1
                write(u'''/bin/touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache \\
  --quiet %{_datadir}/icons/hicolor 2> /dev/null|| :
''')
            #  -DesktopDB
            if VFSL([locals()]+SL+[globals(), builtin],"extra.DesktopDB",True): # generated from line 864, col 1
                write(u'''update-desktop-database %{_datadir}/applications &> /dev/null || :
''')
            #  -Extra Postun Script
            if VFSL([locals()]+SL+[globals(), builtin],"has_extra_postun",True): # generated from line 868, col 1
                write(u'''# >> postun
''')
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.postun.main",True)) # u'$str_newline.join($extra.content.postun.main)' on line 870, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.postun.main)')) # from line 870, col 1.
                write(u'''
# << postun
''')
            #  need postun
        write(u'''
''')
        #  Pre/Preun/Post/Postun for SubPackages
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("SubPackages"): # generated from line 877, col 1
            for sp in VFSL([locals()]+SL+[globals(), builtin],"metadata.SubPackages",True): # generated from line 878, col 1
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("AsWholeName"): # generated from line 879, col 1
                    pkg_name = "-n " + VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)
                else: # generated from line 881, col 1
                    pkg_name = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)
                sub_extra = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra",True),"subpkgs",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]
                #  Pre for SubPackages
                has_extra_pre = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("pre") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.pre",True),"has_key",False)(VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True))
                if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_pre",True): # generated from line 888, col 1
                    write(u'''%pre ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 889, col 6
                    if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 889, col 6.
                    write(u'''
''')
                    #  -Schema
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True): # generated from line 891, col 1
                        write(u'''if [ "$1" -gt 1 ]; then
''')
                        for schema in VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schemas",True): # generated from line 893, col 1
                            write(u'''  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule \\
    ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"schema",True) # u'$schema' on line 896, col 5
                            if _v is not None: write(_filter(_v, rawExpr=u'$schema')) # from line 896, col 5.
                            write(u''' \\
    > /dev/null || :
''')
                        write(u'''fi
''')
                    #  -Extra pre
                    if VFSL([locals()]+SL+[globals(), builtin],"has_extra_pre",True): # generated from line 902, col 1
                        write(u'''# >> pre ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 903, col 10
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 903, col 10.
                        write(u'''
''')
                        _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"pre",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]) # u'$str_newline.join($extra.content.pre[$sp.Name])' on line 904, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.pre[$sp.Name])')) # from line 904, col 1.
                        write(u'''
# << pre ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 905, col 10
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 905, col 10.
                        write(u'''
''')
                write(u'''
''')
                #  Preun for SubPackages
                has_extra_preun = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("preun") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.preun",True),"has_key",False)(VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True))
                if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_preun",True): # generated from line 912, col 1
                    write(u'''%preun ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 913, col 8
                    if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 913, col 8.
                    write(u'''
''')
                    #  -Schema
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True): # generated from line 915, col 1
                        write(u'''if [ "$1" -eq 0 ]; then
''')
                        for schema in VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schemas",True): # generated from line 917, col 1
                            write(u'''  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule \\
    ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"schema",True) # u'$schema' on line 920, col 5
                            if _v is not None: write(_filter(_v, rawExpr=u'$schema')) # from line 920, col 5.
                            write(u''' \\
    > /dev/null || :
''')
                        write(u'''fi
''')
                    #  -Extra preun
                    if VFSL([locals()]+SL+[globals(), builtin],"has_extra_preun",True): # generated from line 926, col 1
                        write(u'''# >> preun ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 927, col 12
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 927, col 12.
                        write(u'''
''')
                        _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"preun",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]) # u'$str_newline.join($extra.content.preun[$sp.Name])' on line 928, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.preun[$sp.Name])')) # from line 928, col 1.
                        write(u'''
# << preun ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 929, col 12
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 929, col 12.
                        write(u'''
''')
                write(u'''
''')
                #  Post for SubPackages
                has_extra_post = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("post") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.post",True),"has_key",False)(VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)) and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"post",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]
                if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Lib",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_post",True): # generated from line 936, col 1
                    only_Lib = not (VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_post",True))
                    if VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 938, col 1
                        write(u'''%post ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 939, col 7
                        if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 939, col 7.
                        write(u''' -p /sbin/ldconfig
''')
                    else: # generated from line 940, col 1
                        write(u'''%post ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 941, col 7
                        if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 941, col 7.
                        write(u'''
''')
                    #  -Lib
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Lib",True) and not VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 944, col 1
                        write(u'''/sbin/ldconfig
''')
                    #  -Schema
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schema",True): # generated from line 948, col 1
                        for schema in VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Schemas",True): # generated from line 949, col 1
                            write(u'''export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule \\
    ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"schema",True) # u'$schema' on line 952, col 5
                            if _v is not None: write(_filter(_v, rawExpr=u'$schema')) # from line 952, col 5.
                            write(u'''  > /dev/null || :
''')
                    #  -Info
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Info",True): # generated from line 956, col 1
                        for inf in VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Infos",True): # generated from line 957, col 1
                            write(u'''%install_info --info-dir=%_infodir ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"inf",True) # u'$inf' on line 958, col 36
                            if _v is not None: write(_filter(_v, rawExpr=u'$inf')) # from line 958, col 36.
                            write(u'''
''')
                        #  Info
                    #  -Icon
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Icon",True): # generated from line 962, col 1
                        write(u'''/bin/touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache \\
  --quiet %{_datadir}/icons/hicolor 2> /dev/null|| :
''')
                    #  -DesktopDB
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.DesktopDB",True): # generated from line 968, col 1
                        write(u'''update-desktop-database %{_datadir}/applications &> /dev/null || :
''')
                    #  -Extra Post Script
                    if VFSL([locals()]+SL+[globals(), builtin],"has_extra_post",True): # generated from line 972, col 1
                        write(u'''# >> post ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 973, col 11
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 973, col 11.
                        write(u'''
''')
                        _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"post",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]) # u'$str_newline.join($extra.content.post[$sp.Name])' on line 974, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.post[$sp.Name])')) # from line 974, col 1.
                        write(u'''
# << post ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 975, col 11
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 975, col 11.
                        write(u'''
''')
                    #  need post
                write(u'''
''')
                #  PostUn for SubPackages
                has_extra_postun = VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("postun") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.postun",True),"has_key",False)(VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)) and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"postun",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]
                if  VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Lib",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_postun",True): # generated from line 982, col 1
                    only_Lib = not (VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Info",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Icon",True) or VFSL([locals()]+SL+[globals(), builtin],"sub_extra.DesktopDB",True) or VFSL([locals()]+SL+[globals(), builtin],"has_extra_postun",True))
                    if VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 984, col 1
                        write(u'''%postun ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 985, col 9
                        if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 985, col 9.
                        write(u''' -p /sbin/ldconfig
''')
                    else: # generated from line 986, col 1
                        write(u'''%postun ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 987, col 9
                        if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 987, col 9.
                        write(u'''
''')
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Lib",True) and not VFSL([locals()]+SL+[globals(), builtin],"only_Lib",True): # generated from line 989, col 1
                        write(u'''/sbin/ldconfig
''')
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Info",True): # generated from line 992, col 1
                        write(u'''if [ $1 = 0 ] ;then
''')
                        for inf in VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Infos",True): # generated from line 994, col 1
                            write(u'''%install_info_delete --info-dir=%{_infodir} ''')
                            _v = VFSL([locals()]+SL+[globals(), builtin],"inf",True) # u'$inf' on line 995, col 45
                            if _v is not None: write(_filter(_v, rawExpr=u'$inf')) # from line 995, col 45.
                            write(u'''
''')
                        write(u'''fi
''')
                        #  Info
                    #  -Icon
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.Icon",True): # generated from line 1000, col 1
                        write(u'''/bin/touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache \\
  --quiet %{_datadir}/icons/hicolor 2> /dev/null|| :
''')
                    #  -DesktopDB
                    if VFSL([locals()]+SL+[globals(), builtin],"sub_extra.DesktopDB",True): # generated from line 1006, col 1
                        write(u'''update-desktop-database %{_datadir}/applications &> /dev/null || :
''')
                    #  -Extra Postun Script
                    if VFSL([locals()]+SL+[globals(), builtin],"has_extra_postun",True): # generated from line 1010, col 1
                        write(u'''# >> postun ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 1011, col 13
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 1011, col 13.
                        write(u'''
''')
                        _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"postun",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]) # u'$str_newline.join($extra.content.postun[$sp.Name])' on line 1012, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.postun[$sp.Name])')) # from line 1012, col 1.
                        write(u'''
# << postun ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 1013, col 13
                        if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 1013, col 13.
                        write(u'''
''')
                    #  need postun
                #  per subpackage
            #  has subpackages
        write(u'''
''')
        if not VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("NoFiles"): # generated from line 1019, col 1
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("LocaleName"): # generated from line 1020, col 1
                write(u'''%files -f ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.LocaleName",True) # u'${metadata.LocaleName}' on line 1021, col 11
                if _v is not None: write(_filter(_v, rawExpr=u'${metadata.LocaleName}')) # from line 1021, col 11.
                write(u'''.lang
''')
            elif VFSL([locals()]+SL+[globals(), builtin],"br_locale",True) != "": # generated from line 1022, col 1
                write(u'''%files -f ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"br_locale",True) # u'${br_locale}' on line 1023, col 11
                if _v is not None: write(_filter(_v, rawExpr=u'${br_locale}')) # from line 1023, col 11.
                write(u'''.lang
''')
            elif VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)('FilesInput'): # generated from line 1024, col 1
                write(u'''%files -f ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"metadata.FilesInput",True) # u'$metadata.FilesInput' on line 1025, col 11
                if _v is not None: write(_filter(_v, rawExpr=u'$metadata.FilesInput')) # from line 1025, col 11.
                write(u'''
''')
            else: # generated from line 1026, col 1
                write(u'''%files
''')
            write(u'''%defattr(-,root,root,-)
''')
            #  TODO to be cleanup
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("Documents"): # generated from line 1031, col 1
                for doc in VFSL([locals()]+SL+[globals(), builtin],"metadata.Documents",True): # generated from line 1032, col 1
                    write(u'''%doc ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"doc",True) # u'$doc' on line 1033, col 6
                    if _v is not None: write(_filter(_v, rawExpr=u'$doc')) # from line 1033, col 6.
                    write(u'''
''')
            if "Files" in VFSL([locals()]+SL+[globals(), builtin],"metadata",True): # generated from line 1036, col 1
                for f in VFSL([locals()]+SL+[globals(), builtin],"metadata.Files",True): # generated from line 1037, col 1
                    _v = VFSL([locals()]+SL+[globals(), builtin],"f",True) # u'$f' on line 1038, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$f')) # from line 1038, col 1.
                    write(u'''
''')
            write(u'''# >> files
''')
            if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("files") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.files",True),"has_key",False)("main"): # generated from line 1042, col 1
                _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFSL([locals()]+SL+[globals(), builtin],"extra.content.files.main",True)) # u'$str_newline.join($extra.content.files.main)' on line 1043, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.files.main)')) # from line 1043, col 1.
                write(u'''
''')
            write(u'''# << files
''')
            #  not NoFiles
        write(u'''
''')
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("AutoSubPackages"): # generated from line 1048, col 1
            for sp in VFSL([locals()]+SL+[globals(), builtin],"metadata.AutoSubPackages",True): # generated from line 1049, col 1
                write(u'''%files ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"sp",True) # u'$sp' on line 1050, col 8
                if _v is not None: write(_filter(_v, rawExpr=u'$sp')) # from line 1050, col 8.
                write(u'''
%defattr(-,root,root,-)
# >> files ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"sp",True) # u'$sp' on line 1052, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'$sp')) # from line 1052, col 12.
                write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("files") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.files",True),"has_key",False)(VFSL([locals()]+SL+[globals(), builtin],"sp",True)): # generated from line 1053, col 1
                    _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"files",True)[VFSL([locals()]+SL+[globals(), builtin],"sp",True)]) # u'$str_newline.join($extra.content.files[$sp])' on line 1054, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.files[$sp])')) # from line 1054, col 1.
                    write(u'''
''')
                write(u'''# << files ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"sp",True) # u'$sp' on line 1056, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'$sp')) # from line 1056, col 12.
                write(u'''

''')
        write(u'''
''')
        #  files for subpkgs
        if VFN(VFSL([locals()]+SL+[globals(), builtin],"metadata",True),"has_key",False)("SubPackages"): # generated from line 1062, col 1
            for sp in VFSL([locals()]+SL+[globals(), builtin],"metadata.SubPackages",True): # generated from line 1063, col 1
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("AsWholeName"): # generated from line 1064, col 1
                    pkg_name = "-n " + VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)
                else: # generated from line 1066, col 1
                    pkg_name = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)('FilesInput'): # generated from line 1069, col 1
                    write(u'''%files ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 1070, col 8
                    if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 1070, col 8.
                    write(u''' -f ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"sp.FilesInput",True) # u'$sp.FilesInput' on line 1070, col 21
                    if _v is not None: write(_filter(_v, rawExpr=u'$sp.FilesInput')) # from line 1070, col 21.
                    write(u'''
''')
                else: # generated from line 1071, col 1
                    write(u'''%files ''')
                    _v = VFSL([locals()]+SL+[globals(), builtin],"pkg_name",True) # u'$pkg_name' on line 1072, col 8
                    if _v is not None: write(_filter(_v, rawExpr=u'$pkg_name')) # from line 1072, col 8.
                    write(u'''
''')
                write(u'''%defattr(-,root,root,-)
''')
                #  TODO to be cleanup
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"sp",True),"has_key",False)("Documents"): # generated from line 1076, col 1
                    for doc in VFSL([locals()]+SL+[globals(), builtin],"sp.Documents",True): # generated from line 1077, col 1
                        write(u'''%doc ''')
                        _v = VFSL([locals()]+SL+[globals(), builtin],"doc",True) # u'$doc' on line 1078, col 6
                        if _v is not None: write(_filter(_v, rawExpr=u'$doc')) # from line 1078, col 6.
                        write(u'''
''')
                if "Files" in VFSL([locals()]+SL+[globals(), builtin],"sp",True): # generated from line 1081, col 1
                    for f in VFSL([locals()]+SL+[globals(), builtin],"sp.Files",True): # generated from line 1082, col 1
                        _v = VFSL([locals()]+SL+[globals(), builtin],"f",True) # u'$f' on line 1083, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'$f')) # from line 1083, col 1.
                        write(u'''
''')
                write(u'''# >> files ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 1086, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 1086, col 12.
                write(u'''
''')
                if VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"has_key",False)("files") and VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content.files",True),"has_key",False)(VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)): # generated from line 1087, col 1
                    _v = VFN(VFSL([locals()]+SL+[globals(), builtin],"str_newline",True),"join",False)(VFN(VFSL([locals()]+SL+[globals(), builtin],"extra.content",True),"files",True)[VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True)]) # u'$str_newline.join($extra.content.files[$sp.Name])' on line 1088, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$str_newline.join($extra.content.files[$sp.Name])')) # from line 1088, col 1.
                    write(u'''
''')
                write(u'''# << files ''')
                _v = VFSL([locals()]+SL+[globals(), builtin],"sp.Name",True) # u'$sp.Name' on line 1090, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'$sp.Name')) # from line 1090, col 12.
                write(u'''

''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_spec= 'respond'

## END CLASS DEFINITION

if not hasattr(spec, '_initCheetahAttributes'):
    templateAPIClass = getattr(spec, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(spec)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=spec()).run()


